proc gsqr(gamm,nnn,grid);                   //G(gamma)^2 = (k=2 to 150 sum of a_k * Z_k)^2

    local kkk, zzz, xxx, jjj, rmax, rmin, N, rrr, gsqre, ddd; 

    rmax = maxc(gamm);
    rmin = minc(gamm);               //gamma = [rmin, rmax]
    N = floor((rmax-rmin)/grid); 
    xxx = zeros(nnn,N+1);
    rrr = seqa(rmin, grid, N+1);
    gsqre = zeros(N+1,1);    

    zzz = rndn(nnn,1);

    jjj = 1;
    do until jjj > rows(rrr);
        ddd = agam(rrr[jjj,1],nnn);
        xxx[.,jjj] = ddd .*zzz[.,1];
        gsqre[jjj,1] = sumc(xxx[2:nnn,jjj])^2;
    jjj = jjj+1;
    endo;

    retp(gsqre);
endp;
